<?php

$path = "/var/tmp/stats";		//cieka do plikw ze statystyk
$hosts_names = 1;		//uywa nazw hostw zamiast IP
$default_sorting = 'download';	//domylne sortowanie ('download' 'upload', 'host')
$skip_zeroes = 1;		//pomija komputery z zerowymi danymi
$time_limit = 300;		//czas (w sekundach), po ktrym komputery zostan
				//uznane za nieaktywne

/*******************************************************************/
$title = 'Statystyka wykorzystania cza v.0.9.8';
$footer = 'Copyright &copy; 2003-2006 A.L.E.C (<a href="http://alec.pl">www.alec.pl</a>)';
$months = array ('stycze','luty','marzec','kwiecie','maj','czerwiec','lipiec','sierpie','wrzesie','padziernik','listopad','grudzie');

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
<HEAD>
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
    <TITLE><?php echo $title; ?></TITLE>
    <LINK rel="stylesheet" href="images/style.css" type="text/css">
</HEAD>
<BODY>

<?php
function setunits($data)
{
	if ( !($data < (1024*1024*1000)) ) {
		$number = $data / (1024*1024*1024);
		$unit = "GB";
	} elseif ( !($data < (1024*1000) ) ) {
		$number = $data / (1024*1024);
		$unit = "MB";
	} else {
		$number = $data / 1024;
		$unit = "KB";
	}
	return array($number, $unit);
}

$now = time();
$date = getdate();
$month = ( isset($_POST['month']) ? $_POST['month'] : $date['mon'] ); 
$year = ( isset($_POST['year']) ? $_POST['year'] : $date['year'] ); 
$sort = ( isset($_POST['sort']) ? $_POST['sort'] : $default_sorting ); 

/****************************************************************/
print '<P class="header">'.$title.'</P>';
print '<P><FORM class="form" name="traffic" method="post" action="stat.php">';
print 'miesic:<SELECT class="select" name="month" OnChange="javascript:document.traffic.submit();">';
for ( $i=1; $i<=12; $i++ ) 
{
	print '<OPTION value="'.$i.'"';
	if ( $i==$month )
		print 'SELECTED';
	print '>'.$months[$i-1].'</OPTION>';
};
print '</SELECT>&nbsp;';
print 'rok:<SELECT class="select" name="year" OnChange="javascript:document.traffic.submit();">';
for ( $i=0; $i<=10; $i++ ) 
{
	print '<OPTION value="'.($i+2012).'"';
	if ( $i==$year-2012 )
		print 'SELECTED';
	print '>'.($i+2012).'</OPTION>';
};
print '</SELECT>&nbsp;';
print 'sortowanie:<SELECT class="select" name="sort" OnChange="javascript:document.traffic.submit();">';
print '<OPTION value="download"'.($sort=='download' ? 'SELECTED' : '').'>download</OPTION>';
print '<OPTION value="upload"'.($sort=='upload' ? 'SELECTED' : '').'>upload</OPTION>';
print '<OPTION value="host"'.($sort=='host' ? 'SELECTED' : '').'>host</OPTION>';
print '</SELECT>';
print '</FORM>';
 
//otwieramy plik ************************
if( !($file = @fopen($path.'/'.$year.$month,'r')) ) 
{
	print '<P class="error"><BR><BR>Brak statystyk z wybranego okresu!</P>';
	die;
}

// inicjujemy zmienne
$hosts = array();
$upload = array();
$download = array();
$active = array();

//czytamy dane
while (!feof($file)) 
	$lines[] = fgets($file,100);
fclose($file);
foreach ($lines as $line) 
{
	$tab = preg_split('/[ \t]+/', $line);
	$host = isset($tab[0]) ? trim($tab[0]) : '';
	$up = isset($tab[1]) ? trim($tab[1]) : 0;
	$down = isset($tab[2]) ? trim($tab[2]) : 0;
	$atime = isset($tab[3]) ? trim($tab[3]) : 0;
	
	if(!$host || ($skip_zeroes && !($up || $down)) ) 
	{
		continue;
	}
	
	$hosts[] = ($hosts_names ? $host : ip2long($host));
	$upload[] = $up;
	$download[] = $down;
	$active[] = $atime>$now-$time_limit ? 1 : 0;
}

// plik jest pusty
if(!sizeof($hosts))
{
	print '<P class="error"><BR><BR>Brak statystyk z wybranego okresu!</P>';
	die;
}

//skalowanie wykresw ********************
$maks_up = max($upload);
$maks_down = max($download);
$maks = ( $maks_up > $maks_down ? $maks_up : $maks_down );
if ($maks == 0) 
	$maks = 1; //co by nie byo dzielenia przez zero

//sortowanie *****************************
switch($sort)
{
	case 'download':
		array_multisort($download, SORT_DESC, $download, $upload, $hosts, $active);
	break;
	case 'upload':
		array_multisort($upload, SORT_DESC, $upload, $download, $hosts, $active);
	break;
	case 'host':
		array_multisort($hosts, SORT_ASC, $hosts, $download, $upload, $active);
	break;
}

print '<P><TABLE cellpadding="3" align="center"><TR><TD>';

//upload *********************************
$sum_upload = array_sum($upload);
print '<TABLE cellpadding="0" class="tables" ALIGN="right">';
print '<TR><TD colspan="2" align="center"><B>Upload</B></TD></TR>';
foreach ($upload as $idx => $data)
{
	list($number, $unit) = setunits($upload[$idx]);
	$d = round($upload[$idx]*200/$maks);
	print '<TR>';
	print '<TD align="right" nowrap>&nbsp;'.($active[$idx] ? '<B>' : '').($hosts_names ? $hosts[$idx] : long2ip($hosts[$idx])).($active[$idx] ? '</B>' : '').'&nbsp;</TD>';
	print '<TD><IMG src="images/bluepx.gif" height="12" width="'.($d ? $d : '1').'" align="absmiddle" alt="" border="1">&nbsp;';
	printf('%0.2f&nbsp;%s&nbsp;(%0.1f%%)</TD>', $number, $unit, ($upload[$idx]*100/max(1,$sum_upload)));
	print '</TR>';
}
$sum = setunits($sum_upload);
print '<TR><TD colspan="2" align="center"><B>RAZEM: '.sprintf('%0.2f',$sum[0]).' '.$sum[1].'</B></TD></TR>';
print '</TABLE>';

print '</TD><TD>';

//download *******************************
$sum_download = array_sum($download);
print '<TABLE cellpadding="0" class="tables" align="center">';
print '<TR><TD colspan="2" align="center"><B>Download</B></TD></TR>';
foreach ($download as $idx => $data)
{
	list($number, $unit) = setunits($download[$idx]);
	$d = round($download[$idx]*200/$maks);
	print '<TR>';
	print '<TD align="right" nowrap>&nbsp;'.($active[$idx] ? '<B>' : '').($hosts_names ? $hosts[$idx] : long2ip($hosts[$idx])).($active[$idx] ? '</B>' : '').'&nbsp;</TD>';
	print '<TD><IMG src="images/redpx.gif" height="12" width="'.($d ? $d : '1').'" alt="" align="absmiddle" border="1">&nbsp;';
	printf('%0.2f&nbsp;%s&nbsp;(%0.1f%%)</TD>', $number, $unit, ($download[$idx]*100/max(1,$sum_download)));
	print '</TR>';
}
$sum = setunits($sum_download);
print '<TR><TD colspan="2" align="center"><B>RAZEM: '.sprintf('%0.2f',$sum[0]).' '.$sum[1].'</B></TD></TR>';
print '</TABLE>';

print '</TD></TR><TR><TD colspan="2" align="center" class="footer"><P>'.$footer.'</P></TD></TR></TABLE>';

?>
